/* This file has been generated by the Perl script `afblue.pl', */
/* using data from file `afblue.dat'.                           */

/***************************************************************************/
/*                                                                         */
/*  afblue.h                                                               */
/*                                                                         */
/*    Auto-fitter data for blue strings (specification).                   */
/*                                                                         */
/*  Copyright 2013-2016 by                                                 */
/*  David Turner, Robert Wilhelm, and Werner Lemberg.                      */
/*                                                                         */
/*  This file is part of the FreeType project, and may only be used,       */
/*  modified, and distributed under the terms of the FreeType project      */
/*  license, LICENSE.TXT.  By continuing to use, modify, or distribute     */
/*  this file you indicate that you have read the license and              */
/*  understand and accept it fully.                                        */
/*                                                                         */
/***************************************************************************/


#ifndef AFBLUE_H_
#define AFBLUE_H_


FT_BEGIN_HEADER


  /* an auxiliary macro to decode a UTF-8 character -- since we only use */
  /* hard-coded, self-converted data, no error checking is performed     */
#define GET_UTF8_CHAR( ch, p )                      \
          do                                        \
          {                                         \
            ch = (unsigned char)*p++;               \
            if ( ch >= 0x80 )                       \
            {                                       \
              FT_UInt  len_;                        \
                                                    \
                                                    \
              if ( ch < 0xE0 )                      \
              {                                     \
                len_ = 1;                           \
                ch  &= 0x1F;                        \
              }                                     \
              else if ( ch < 0xF0 )                 \
              {                                     \
                len_ = 2;                           \
                ch  &= 0x0F;                        \
              }                                     \
              else                                  \
              {                                     \
                len_ = 3;                           \
                ch  &= 0x07;                        \
              }                                     \
                                                    \
              for ( ; len_ > 0; len_-- )            \
                ch = ( ch << 6 ) | ( *p++ & 0x3F ); \
            }                                       \
          } while ( 0 )


  /*************************************************************************/
  /*************************************************************************/
  /*****                                                               *****/
  /*****                    B L U E   S T R I N G S                    *****/
  /*****                                                               *****/
  /*************************************************************************/
  /*************************************************************************/

  /* At the bottommost level, we define strings for finding blue zones. */


#define AF_BLUE_STRING_MAX_LEN  51

  /* The AF_Blue_String enumeration values are offsets into the */
  /* `af_blue_strings' array.                                   */

  typedef enum  AF_Blue_String_
  {
    AF_BLUE_STRING_ARABIC_TOP = 0,
    AF_BLUE_STRING_ARABIC_BOTTOM = 18,
    AF_BLUE_STRING_ARABIC_JOIN = 33,
    AF_BLUE_STRING_ARMENIAN_CAPITAL_TOP = 36,
    AF_BLUE_STRING_ARMENIAN_CAPITAL_BOTTOM = 60,
    AF_BLUE_STRING_ARMENIAN_SMALL_ASCENDER = 84,
    AF_BLUE_STRING_ARMENIAN_SMALL_TOP = 108,
    AF_BLUE_STRING_ARMENIAN_SMALL_BOTTOM = 132,
    AF_BLUE_STRING_ARMENIAN_SMALL_DESCENDER = 156,
    AF_BLUE_STRING_BENGALI_BASE = 180,
    AF_BLUE_STRING_BENGALI_TOP = 212,
    AF_BLUE_STRING_BENGALI_HEAD = 240,
    AF_BLUE_STRING_CYRILLIC_CAPITAL_TOP = 272,
    AF_BLUE_STRING_CYRILLIC_CAPITAL_BOTTOM = 296,
    AF_BLUE_STRING_CYRILLIC_SMALL = 320,
    AF_BLUE_STRING_CYRILLIC_SMALL_DESCENDER = 344,
    AF_BLUE_STRING_DEVANAGARI_BASE = 353,
    AF_BLUE_STRING_DEVANAGARI_TOP = 385,
    AF_BLUE_STRING_DEVANAGARI_HEAD = 417,
    AF_BLUE_STRING_DEVANAGARI_BOTTOM = 449,
    AF_BLUE_STRING_ETHIOPIC_TOP = 457,
    AF_BLUE_STRING_ETHIOPIC_BOTTOM = 489,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_TOP = 521,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_BOTTOM = 553,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_ASCENDER = 585,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_DESCENDER = 617,
    AF_BLUE_STRING_GEORGIAN_ASOMTAVRULI_TOP = 649,
    AF_BLUE_STRING_GEORGIAN_ASOMTAVRULI_BOTTOM = 681,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_TOP = 713,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_BOTTOM = 745,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_ASCENDER = 777,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_DESCENDER = 809,
    AF_BLUE_STRING_GREEK_CAPITAL_TOP = 841,
    AF_BLUE_STRING_GREEK_CAPITAL_BOTTOM = 862,
    AF_BLUE_STRING_GREEK_SMALL_BETA_TOP = 880,
    AF_BLUE_STRING_GREEK_SMALL = 898,
    AF_BLUE_STRING_GREEK_SMALL_DESCENDER = 922,
    AF_BLUE_STRING_GUJARATI_TOP = 946,
    AF_BLUE_STRING_GUJARATI_BOTTOM = 978,
    AF_BLUE_STRING_GUJARATI_ASCENDER = 1010,
    AF_BLUE_STRING_GUJARATI_DESCENDER = 1060,
    AF_BLUE_STRING_GUJARATI_DIGIT_TOP = 1093,
    AF_BLUE_STRING_GURMUKHI_BASE = 1113,
    AF_BLUE_STRING_GURMUKHI_HEAD = 1145,
    AF_BLUE_STRING_GURMUKHI_TOP = 1177,
    AF_BLUE_STRING_GURMUKHI_BOTTOM = 1209,
    AF_BLUE_STRING_GURMUKHI_DIGIT_TOP = 1241,
    AF_BLUE_STRING_HEBREW_TOP = 1261,
    AF_BLUE_STRING_HEBREW_BOTTOM = 1285,
    AF_BLUE_STRING_HEBREW_DESCENDER = 1303,
    AF_BLUE_STRING_KANNADA_TOP = 1318,
    AF_BLUE_STRING_KANNADA_BOTTOM = 1362,
    AF_BLUE_STRING_KHMER_TOP = 1394,
    AF_BLUE_STRING_KHMER_SUBSCRIPT_TOP = 1418,
    AF_BLUE_STRING_KHMER_BOTTOM = 1458,
    AF_BLUE_STRING_KHMER_DESCENDER = 1490,
    AF_BLUE_STRING_KHMER_LARGE_DESCENDER = 1524,
    AF_BLUE_STRING_KHMER_SYMBOLS_WAXING_TOP = 1611,
    AF_BLUE_STRING_KHMER_SYMBOLS_WANING_BOTTOM = 1619,
    AF_BLUE_STRING_LAO_TOP = 1627,
    AF_BLUE_STRING_LAO_BOTTOM = 1659,
    AF_BLUE_STRING_LAO_ASCENDER = 1691,
    AF_BLUE_STRING_LAO_LARGE_ASCENDER = 1707,
    AF_BLUE_STRING_LAO_DESCENDER = 1719,
    AF_BLUE_STRING_LATIN_CAPITAL_TOP = 1743,
    AF_BLUE_STRING_LATIN_CAPITAL_BOTTOM = 1759,
    AF_BLUE_STRING_LATIN_SMALL_F_TOP = 1775,
    AF_BLUE_STRING_LATIN_SMALL = 1789,
    AF_BLUE_STRING_LATIN_SMALL_DESCENDER = 1803,
    AF_BLUE_STRING_LATIN_SUBS_CAPITAL_TOP = 1813,
    AF_BLUE_STRING_LATIN_SUBS_CAPITAL_BOTTOM = 1833,
    AF_BLUE_STRING_LATIN_SUBS_SMALL_F_TOP = 1853,
    AF_BLUE_STRING_LATIN_SUBS_SMALL = 1873,
    AF_BLUE_STRING_LATIN_SUBS_SMALL_DESCENDER = 1909,
    AF_BLUE_STRING_LATIN_SUPS_CAPITAL_TOP = 1929,
    AF_BLUE_STRING_LATIN_SUPS_CAPITAL_BOTTOM = 1960,
    AF_BLUE_STRING_LATIN_SUPS_SMALL_F_TOP = 1989,
    AF_BLUE_STRING_LATIN_SUPS_SMALL = 2015,
    AF_BLUE_STRING_LATIN_SUPS_SMALL_DESCENDER = 2040,
    AF_BLUE_STRING_MALAYALAM_TOP = 2051,
    AF_BLUE_STRING_MALAYALAM_BOTTOM = 2095,
    AF_BLUE_STRING_MYANMAR_TOP = 2127,
    AF_BLUE_STRING_MYANMAR_BOTTOM = 2159,
    AF_BLUE_STRING_MYANMAR_ASCENDER = 2191,
    AF_BLUE_STRING_MYANMAR_DESCENDER = 2219,
    AF_BLUE_STRING_SINHALA_TOP = 2251,
    AF_BLUE_STRING_SINHALA_BOTTOM = 2283,
    AF_BLUE_STRING_SINHALA_DESCENDER = 2315,
    AF_BLUE_STRING_TAMIL_TOP = 2359,
    AF_BLUE_STRING_TAMIL_BOTTOM = 2391,
    AF_BLUE_STRING_TELUGU_TOP = 2423,
    AF_BLUE_STRING_TELUGU_BOTTOM = 2451,
    AF_BLUE_STRING_THAI_TOP = 2479,
    AF_BLUE_STRING_THAI_BOTTOM = 2503,
    AF_BLUE_STRING_THAI_ASCENDER = 2531,
    AF_BLUE_STRING_THAI_LARGE_ASCENDER = 2543,
    AF_BLUE_STRING_THAI_DESCENDER = 2555,
    AF_BLUE_STRING_THAI_LARGE_DESCENDER = 2571,
    AF_BLUE_STRING_THAI_DIGIT_TOP = 2579,
    af_blue_1_1 = 2590,
#ifdef AF_CONFIG_OPTION_CJK
    AF_BLUE_STRING_CJK_TOP = af_blue_1_1 + 1,
    AF_BLUE_STRING_CJK_BOTTOM = af_blue_1_1 + 203,
    af_blue_1_1_1 = af_blue_1_1 + 404,
#ifdef AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT
    AF_BLUE_STRING_CJK_LEFT = af_blue_1_1_1 + 1,
    AF_BLUE_STRING_CJK_RIGHT = af_blue_1_1_1 + 204,
    af_blue_1_1_2 = af_blue_1_1_1 + 405,
#else
    af_blue_1_1_2 = af_blue_1_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT */
    af_blue_1_2 = af_blue_1_1_2 + 0,
#else
    af_blue_1_2 = af_blue_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK                */


    AF_BLUE_STRING_MAX   /* do not remove */

  } AF_Blue_String;


  FT_LOCAL_ARRAY( char )
  af_blue_strings[];


  /*************************************************************************/
  /*************************************************************************/
  /*****                                                               *****/
  /*****                 B L U E   S T R I N G S E T S                 *****/
  /*****                                                               *****/
  /*************************************************************************/
  /*************************************************************************/

  /* The next level is to group blue strings into style-specific sets. */


  /* Properties are specific to a writing system.  We assume that a given  */
  /* blue string can't be used in more than a single writing system, which */
  /* is a safe bet.                                                        */
#define AF_BLUE_PROPERTY_LATIN_TOP       ( 1U << 0 )  /* must have value 1 */
#define AF_BLUE_PROPERTY_LATIN_SUB_TOP   ( 1U << 1 )
#define AF_BLUE_PROPERTY_LATIN_NEUTRAL   ( 1U << 2 )
#define AF_BLUE_PROPERTY_LATIN_X_HEIGHT  ( 1U << 3 )
#define AF_BLUE_PROPERTY_LATIN_LONG      ( 1U << 4 )

#define AF_BLUE_PROPERTY_CJK_TOP    ( 1U << 0 )       /* must have value 1 */
#define AF_BLUE_PROPERTY_CJK_HORIZ  ( 1U << 1 )       /* must have value 2 */
#define AF_BLUE_PROPERTY_CJK_RIGHT  AF_BLUE_PROPERTY_CJK_TOP


#define AF_BLUE_STRINGSET_MAX_LEN  8

  /* The AF_Blue_Stringset enumeration values are offsets into the */
  /* `af_blue_stringsets' array.                                   */

  typedef enum  AF_Blue_Stringset_
  {
    AF_BLUE_STRINGSET_ARAB = 0,
    AF_BLUE_STRINGSET_ARMN = 4,
    AF_BLUE_STRINGSET_BENG = 11,
    AF_BLUE_STRINGSET_CYRL = 16,
    AF_BLUE_STRINGSET_DEVA = 22,
    AF_BLUE_STRINGSET_ETHI = 28,
    AF_BLUE_STRINGSET_GEOR = 31,
    AF_BLUE_STRINGSET_GEOK = 36,
    AF_BLUE_STRINGSET_GREK = 43,
    AF_BLUE_STRINGSET_GUJR = 50,
    AF_BLUE_STRINGSET_GURU = 56,
    AF_BLUE_STRINGSET_HEBR = 62,
    AF_BLUE_STRINGSET_KNDA = 66,
    AF_BLUE_STRINGSET_KHMR = 69,
    AF_BLUE_STRINGSET_KHMS = 75,
    AF_BLUE_STRINGSET_LAO = 78,
    AF_BLUE_STRINGSET_LATN = 84,
    AF_BLUE_STRINGSET_LATB = 91,
    AF_BLUE_STRINGSET_LATP = 98,
    AF_BLUE_STRINGSET_MLYM = 105,
    AF_BLUE_STRINGSET_MYMR = 108,
    AF_BLUE_STRINGSET_NONE = 113,
    AF_BLUE_STRINGSET_SINH = 114,
    AF_BLUE_STRINGSET_TAML = 118,
    AF_BLUE_STRINGSET_TELU = 121,
    AF_BLUE_STRINGSET_THAI = 124,
    af_blue_2_1 = 132,
#ifdef AF_CONFIG_OPTION_CJK
    AF_BLUE_STRINGSET_HANI = af_blue_2_1 + 0,
    af_blue_2_1_1 = af_blue_2_1 + 2,
#ifdef AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT
    af_blue_2_1_2 = af_blue_2_1_1 + 2,
#else
    af_blue_2_1_2 = af_blue_2_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT */
    af_blue_2_2 = af_blue_2_1_2 + 1,
#else
    af_blue_2_2 = af_blue_2_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK                */


    AF_BLUE_STRINGSET_MAX   /* do not remove */

  } AF_Blue_Stringset;


  typedef struct  AF_Blue_StringRec_
  {
    AF_Blue_String  string;
    FT_UShort       properties;

  } AF_Blue_StringRec;


  FT_LOCAL_ARRAY( AF_Blue_StringRec )
  af_blue_stringsets[];

/* */

FT_END_HEADER


#endif /* AFBLUE_H_ */


/* END */
